/*## (c) SECURITY EXPLORATIONS    2014 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.lang.invoke.*;
import java.security.*;
import java.util.*;
import java.io.*;

public class Helper {

 public static Object create(Constructor con,Object[] args) throws Throwable {
  return con.newInstance(args);
 }

 public static Object invoke(Method m,Object o,Object[] args) throws Throwable {
  return m.invoke(o,args);
 }

 public static Object get(Field f,Object o) throws Throwable {
  return f.get(o);
 }

 public static void set(Field f,Object o,Object val) throws Throwable {
  f.set(o,val);
 }

 public static Object get_loader(ProtectionDomain pd) throws Throwable {
  return pd.getClassLoader();
 }

 public static void enable_classpath(ClassLoader rcl,PrintWriter out) throws Throwable {
  try {
   Class c=rcl.getClass();

   Method m1=c.getMethod("getImplUrls",new Class[0]);
   Method m2=c.getMethod("getSharedUrls",new Class[0]);

   HashSet impl_urls=(HashSet)m1.invoke(rcl,new Object[0]);
   HashSet shared_urls=(HashSet)m2.invoke(rcl,new Object[0]);

   out.println("org impl_urls: "+impl_urls);
   out.println("org shared_urls: "+shared_urls);

   Object urls[]=impl_urls.toArray();

   for(int i=0;i<urls.length;i++) {
    shared_urls.add(urls[i]);
   }

   out.println("impl_urls: "+impl_urls);
   out.println("shared_urls: "+shared_urls);
  } catch(Throwable t) {t.printStackTrace(out);}
 }

}
